//
//  ChannelColumns.cpp
//  gtk_channels
//
//  Created by Arnaud Blanchard on 13/10/2019.
//

#include "ChannelColumns.hpp"

using namespace Glib;
using namespace Gtk;
using namespace std;

ChannelColumns::ChannelColumns(){
    add(id);
    add(name);
    add(type);
    add(format);
    add(dimensions);
    add(terminal_icon);
    add(play_pause_icon);
    add(play_pause_sensitive);
    add(stop_icon);
    add(stop_sensitive);
    add(pid);
    add(process);
}

void ChannelColumns::add_channel(RefPtr<TreeStore> tree, blc_channel const &channel){
    uint32_t type_str, format_str;
    char dims_str[256];
    TreeModel::Row childrow;
    
    auto row = *(tree->append()); //* is because it is an iterator and we want the content of the ref.
    row[name] = channel.name;
    row[type] = string(UINT32_TO_STRING(type_str, channel.type), 4);
    row[format] = string(UINT32_TO_STRING(format_str, channel.format), 4);
    channel.sprint_dims(dims_str, 256);
    row[dimensions] = dims_str;
    row[process]=nullptr;
    row[id]=channel.id;
}
