//
//  ChannelColumns.hpp
//  gtk_channels
//
//  Created by Arnaud Blanchard on 13/10/2019.
//

#ifndef ChannelColumns_hpp
#define ChannelColumns_hpp

#include "blc_channel.h"
#include "Process.h"

#include <stdio.h>
#include <string>
#include <gtkmm.h>

struct ChannelWidget;

struct ChannelColumns : public Gtk::TreeModel::ColumnRecord{
    Gtk::TreeModelColumn<int> id, pid;
    Gtk::TreeModelColumn<bool> play_pause_sensitive, stop_sensitive;
    Gtk::TreeModelColumn<std::string> name, type, format, dimensions, terminal_icon, play_pause_icon, stop_icon;
    Gtk::TreeModelColumn<Process*> process;
    
    ChannelWidget *channel_widget;
    
    ChannelColumns();
    void add_channel(Glib::RefPtr<Gtk::TreeStore> tree, blc_channel const &channel);
};

#endif /* ChannelColumns_hpp */
