//
//  Process.hpp
//  e_bash
//
//  Created by Arnaud Blanchard on 30/08/2017.
//
//

#ifndef PROCESS_H
#define PROCESS_H

#include <vector>
#include <string>
#include <thread>
#include <gtkmm.h>
#include <vte/vte.h>

struct Process{
    enum Status{paused, stopped, running} status=stopped;
    pid_t pid;
    std::string name;
    std::string directory;
    std::string program_name;
    std::string command_path;
    std::vector<const char*> arg_vector;
    VteTerminal *terminal;
    Gtk::Window *terminal_window=nullptr;
    std::function<void(Process *)> after_launch;
    std::function<void(int exit_status)> on_quit_callback;

    Process(char const* const* argv, std::function<void(Process*)> on_launch);
    
    void run(std::function<void(Process*)> on_launch);
    void run();

    void stop();
    void pause();
    void cont();


    void display_terminal();
    void on_quit(std::function<void(int exit_status)> on_quit);
    void signal(int signal) const;

};
#endif /* Process_hpp */
