#include "ChannelWidget.hpp"
#include "blc_program.h"
#include <gtkmm.h>

using namespace std;
using namespace Gtk;

struct App:Application{
    App(int &argc, char **&argv);
    ApplicationWindow main_window;
    GtkScrolledWindow channel_window;
    ChannelWidget channel_widget;
    
    //Overrides of default signal handlers:
    void on_startup() override; //This is called for the first instance of the app
    void on_activate() override; //This is called a new instance of the app is called (i.e already existing)
};

App::App(int &argc, char **&argv):Application(argc, argv){}

void App::on_startup(){
    Application::on_startup();
    add_action("quit", [](){
        exit(0);
    });
  }

void App::on_activate(){
    Application::on_activate();
    add_window(main_window);
    main_window.add(channel_widget);
    main_window.show_all();
}

int main(int argc, char **argv)
{
    App app(argc, argv); //Argc argv allow to interpret option --g-fatal-warnings for debugging
    
    blc_program_set_description("Graphical interface for blaar programs");
    blc_program_init(&argc, &argv, blc_quit);
    
    return app.run(0, 0);
}


