//
//  Display.hpp
//  c_gtk_image
//
//  Created by Arnaud Blanchard on 12/11/2020.
//

#ifndef Display_hpp
#define Display_hpp

#include "UIN8_Y800.hpp"
#include "blc_array.h"
#include "cairo.h"
#include "gtk/gtk.h"

class Display:public blc_array{
public:
    Display(blc_array const &array);
    ~Display();
    void update();
    void framerate();
    void update_zoom();
        
    static void histogram_cb();

    double min_val, max_val;
    int iterations_nb;
    
    GtkWidget *histogram_button;
    GtkWidget *widget;
    GtkWidget *fit_button;
    std::unique_ptr<Image> image;
    std::unique_ptr<Histogram> histogram;
    GtkWidget *toolbar, *general_statusbar, *framerate_statusbar, *pointer_statusbar, *panel;
};


class UIN8_UYVY_display:public Display{
    void snprint_pixel(char *text, int size_max, int i, int j);
    void snprint_histogram(char *text, int size_max, int i);
public:
    UIN8_UYVY_display(blc_array const &array);
    void update();
    void show_histogram();
    void hide_histogram();
    
    uint32_t *image_data;
    static uint32_t *RGBA_from_YUYV;
};
#endif /* Display_hpp */
