//
//  Histogram.hpp
//  c_gtk_image
//
//  Created by Arnaud Blanchard on 12/11/2020.
//

#ifndef Histogram_h
#define Histogram_h

#include <vector>
#include <blc_array.h>
#include <cairo.h>
#include <gtk/gtk.h>
#include <string>

class Histogram:public blc_array{
    static void resize_cb(GtkWidget *widget, GdkRectangle *allocation, Histogram *histogram);
protected:
    void refresh();
    double x_scale, y_scale;
public:
    Histogram(blc_array const &array);
    virtual ~Histogram() = default;
    bool get_pointer_position(int &i);
    
    virtual void update() = 0;
    virtual void update_pointer_info()=0 ;

    std::string pointer_info;
    cairo_surface_t *surface;
    size_t width, height;
    int iterations_nb;
    uchar *surface_data;
    GdkWindow *window;
    GdkDevice *pointer_device;
    GtkWidget *toolbar, *general_statusbar, *framerate_statusbar, *pointer_statusbar;
    GtkWidget *widget, *image, *scrolled_window, *legend_box;
};
#endif /* Histogram_h */
