
//
//  Display.cpp
//  c_gtk_image
//
//  Created by Arnaud Blanchard on 12/11/2020.
//
#include "Image.hpp"

Image::Image(blc_array const &array):blc_array(array){    
    widget=gtk_scrolled_window_new(nullptr, nullptr);
 //   gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(widget), GTK_POLICY_ALWAYS, GTK_POLICY_ALWAYS);
    GdkDisplay* default_display = gdk_display_get_default();
    GdkSeat* seat = gdk_display_get_default_seat(default_display);
    pointer_device = gdk_seat_get_pointer(seat);
    window=gtk_widget_get_window(widget);

    gtk_widget_set_vexpand(GTK_WIDGET(widget), TRUE);
    image = gtk_image_new();
    gtk_container_add(GTK_CONTAINER(widget), image );
    
    

//    GtkWidget* event_box=gtk_event_box_new();
  //  gtk_container_add(GTK_CONTAINER(event_box), image);
  //  gtk_container_add(GTK_CONTAINER(widget), event_box );

//    gtk_widget_set_vexpand(widget, TRUE);
//    gtk_widget_set_size_request(widget, width, height);
    
    g_signal_connect(G_OBJECT(image), "size-allocate", G_CALLBACK(resize_cb), this);
}

Image::~Image(){
    data=nullptr; //To avoid to free the data twice here, and by the calling array;
}

bool Image::get_pointer_position(int &i, int &j){
    int x, y;
    gdk_window_get_device_position(window, pointer_device, &x, &y, nullptr);
    i=x*x_scale;
    j=y*y_scale;
    
    return (i >=0 && i<width && j>=0 && j<height);
}

void Image::active_fit_size(){
    fit_size=true;
  //  cairo_surface_set_device_scale(surface, (double)width/allocation->width, (double)height/(double)allocation->height);
}

void Image::zoom_original(){
    fit_size=false;
    x_scale=1;
    y_scale=1;
    cairo_surface_set_device_scale(surface, x_scale, y_scale);
    gtk_widget_set_size_request(widget, width/x_scale, height/y_scale);

  //  auto image_height=gtk_widget_get_allocated_height(image);
   // auto window_height = gtk_widget_get_allocated_height(image);
    
   // if (fit_size) gtk_window_resize(GTK_WINDOW(image), width, window_height-image_height+height );*/
}

void Image::zoom(double factor){
    fit_size=false;
    x_scale*=factor;
    y_scale*=factor;
    cairo_surface_set_device_scale(surface, x_scale, y_scale);
    
    gtk_widget_set_size_request(widget, width/x_scale, height/y_scale);
  /*  auto image_height=gtk_widget_get_allocated_height(image);
    auto image_width=gtk_widget_get_allocated_width(image);*/


//    gtk_widget_size_request(GTK_WINDOW(image), width, height );

}

void Image::resize(int allocated_width, int allocated_height){
    x_scale=double(width)/double(allocated_width);
    y_scale=double(height)/double(allocated_height);
    cairo_surface_set_device_scale(surface, x_scale, y_scale);
}

// static
void Image::resize_cb(GtkWidget *widget,  GdkRectangle *allocation, Image *image){
    if (image->fit_size) image->resize(allocation->width, allocation->height);

 
    //  else  if (display->legend_surface) cairo_surface_set_device_scale(display->legend_surface, 256/(double)allocation->width, 1/(double)allocation->height);
}
